*
*/////////////////////////////
*// /
*//  
*/////////////////////////////
*
PROCEDURE CopyData(tcLevFrom, tcKeyLevFrom, tcLevTo, tcKeyLevTo, tlCut, toEngine)
IF VARTYPE(toEngine) # 'O' OR ISNULL(toEngine)
	RETURN .F.
ENDIF	
LOCAL lnRecObjs, llRetVal
lnRecObjs = GetLstObjs(tcLevFrom, toEngine)
IF lnRecObjs > 0 AND USED('lst_subobj')
	LOCAL lnLevTo, lcLevTo, llIsErr, lcFileNameTo, lcOrderTo
	lnLevTo = INT(VAL(tcLevTo))
	lcLevTo = tcLevTo
	WITH toEngine
		lcFileNameTo = .cPrefNameLevel+lcLevTo
		lcOrderTo = .cPrefKeyLevel+lcLevTo
	ENDWITH
	IF !USED(lcFileNameTo)
		USE (toEngine.cDbcName+'!'+lcFileNameTo) IN 0 SHARED
	ENDIF
	llIsErr = !USED(lcFileNameTo) OR !USED('')
	IF !llIsErr
		SET ORDER TO TAG (lcOrderTo) IN (lcFileNameTo)
		llIsErr = !SEEK(tcKeyLevTo, lcFileNameTo, lcOrderTo)
	ENDIF	
	IF !llIsErr
		LOCAL lcCurLevel
		SELECT 
		SELECT lst_subobj
		GO TOP
		lcCurLevel = lst_subobj.Level
		SCAN
			*
			*-- Get object
			IF !SEEK(lst_subobj.id_obj, '', 'id_obj')
				*
				*-- Not found object ???
				LOOP
			ENDIF
			*
			*-- Check level
			IF !(lcCurLevel == lst_subobj.Level)
				*
				*-- To child level
				lnLevTo = lnLevTo+1
				WITH toEngine
					IF lnLevTo > .nMaxLevel
						*
						*-- limit level
						llIsErr = .T.
						EXIT
					ENDIF
					lcLevTo = .GetNumPartName(lnLevTo)
					lcFileNameTo = .cPrefNameLevel+lcLevTo
					lcOrderTo = .cPrefKeyLevel+lcLevTo
				ENDWITH
				IF !USED(lcFileNameTo)
					USE (toEngine.cDbcName+'!'+lcFileNameTo) IN 0 SHARED
				ENDIF
				IF !USED(lcFileNameTo)
					llIsErr = .T.
					EXIT
				ENDIF
			ENDIF
			APPEND BLANK IN (lcFileNameTo)
			IF CURSORGETPROP('Buffering', lcFileNameTo) # 1
				IF !TABLEUPDATE(.F., .T., lcFileNameTo)
					=TABLEREVERT(.F., lcFileNameTo)
					EXIT
				ENDIF
			ENDIF
		ENDSCAN
	ENDIF	
ENDIF
IF USED('lst_subobj')	
	SELECT lst_subobj
	USE
ENDIF	
RETURN llRetVal
ENDFUNC
*
*/////////////////////////////
*//   
*/////////////////////////////
*
PROCEDURE DelSubObjs()
IF !USED('') OR !USED('lst_subobj') OR !USED('_')
	RETURN .F.
ENDIF
LOCAL lnOldArea, llIsChange
lnOldArea = SELECT()
SELECT lst_subobj
LOCAL llRetVal
llRetVal = .T.
SCAN
	IF SEEK(lst_subobj.id_obj, '', 'id_obj')
		IF _.id_objtype # .id_objtype
			IF !SEEK(.id_objtype, '_', 'id_objtype')
				*
				*-- Not found ???
				LOOP
			ENDIF
		ENDIF
		llIsChange = .F.
		IF .counter <= 1
			IF _.deleted
				IF !DELETED('')
					DELETE IN 
					llIsChange = .F.
				ENDIF
			ENDIF	
		ELSE
			REPLACE .counter WITH .counter-1 IN 
			llIsChange = .F.
		ENDIF	
		IF llIsChange AND CURSORGETPROP('Buffering', '') # 1
			IF !TABLEUPDATE(.F., .T., '')
				=TABLEREVERT(.F., '')
				llRetVal = .F.
			ENDIF
		ENDIF
	ENDIF
ENDSCAN
USE
SELECT (lnOldArea)
RETURN llRetVal
ENDFUNC

*
*/////////////////////////////
*//   
*//  
*/////////////////////////////
*
PROCEDURE UnionObjs(tcNumSub, tcIdCode, tcTopNum)
IF !USED('lst_subobj')
	SELECT 0
	CREATE CURSOR lst_subobj (level c(3), id_obj c(10))
ENDIF
IF !USED('lst_subobj')
	RETURN 0
ENDIF

LOCAL lnRecs, lcLevel
lnRecs = 0
IF VARTYPE(tcIdCode) = 'C' AND !EMPTY(tcIdCode)
	IF VARTYPE(tcTopNum) # 'C'
		tcTopNum = ''
	ENDIF
	INSERT INTO lst_subobj (level, id_obj) ;
		VALUES (tcTopNum, tcIdCode)
	lnRecs = 1
ENDIF
IF VARTYPE(tcNumSub) = 'C' AND !EMPTY(tcNumSub)
	LOCAL lcFrom, lcLevel
	lcLevel = "'"+tcNumSub+"'"
	lcFrom = 'Obj_'+tcNumSub
	SELECT * FROM lst_subobj ;
		UNION ;
		SELECT &lcLevel as Level, id_obj FROM (lcFrom) INTO CURSOR lst_subobj
	lnRecs = _TALLY
ENDIF
RETURN lnRecs
ENDFUNC

*
*/////////////////////////////
*//   
*//  
*/////////////////////////////
*
PROCEDURE GetLstObjs(tcTopLel, toEngine)
IF VARTYPE(toEngine) # 'O' OR ISNULL(toEngine)
	RETURN 0
ENDIF	
LOCAL lnRecs
lnRecs = GetTopObjs(tcTopLel, toEngine)
IF lnRecs <= 1
	RETURN lnRecs
ENDIF

LOCAL lnCntLev, lcCurLev, lcSubLev, lnCurRecs, lnFrom
lnFrom = INT(VAL(tcTopLel))+1
WITH toEngine
	lcCurLev = .GetNumPartName(lnFrom)
	FOR lnCntLev = lnFrom TO .nMaxLevel-1
		lcSubLev = .GetNumPartName(lnCntLev+1)
		lnCurRecs = GetSubObjs(lcCurLev, lcSubLev, toEngine)
		IF lnCurRecs = 0
			EXIT
		ENDIF
		lcCurLev = lcSubLev
		lnRecs = lnCurRecs
	ENDFOR
ENDWITH	
RETURN lnRecs
ENDFUNC

*
*/////////////////////////////
*//   
*//  
*//   
*/////////////////////////////
*
PROCEDURE GetTopObjs(tcNumTop, toEngine)
IF VARTYPE(toEngine) # 'O' OR ISNULL(toEngine)
	RETURN 0
ENDIF	

LOCAL lcNum, lcSubNum, lcCode, lcFile, lcFld, lcFldSub, lcIdObj
IF VARTYPE(tcNumTop) # 'C' OR EMPTY(tcNumTop)
	lcNum = toEngine.GetNumPartName(1)
ELSE
	lcNum = tcNumTop
ENDIF

*
*--   
*--   
IF USED('lst_subobj')
	SELECT lst_subobj
	USE
ENDIF

LOCAL lcPrefNameLevel, lcPrefKeyLevel
WITH toEngine
	lcPrefNameLevel = .cPrefNameLevel
	lcPrefKeyLevel = .cPrefKeyLevel
	lcSubNum = .GetNumPartName(INT(VAL(lcNum))+1)
	lcFile = .cDbcName+'!'+lcPrefNameLevel+lcSubNum+' s'
ENDWITH	
lcCode = EVALUATE(lcPrefNameLevel+lcNum+'.'+lcPrefKeyLevel+lcNum) 	&&<- Level id parent object
lcIdObj = EVALUATE(lcPrefNameLevel+lcNum+'.id_obj')					&&<- Code parent object
lcFld = 's.'+lcPrefKeyLevel+lcNum
lcFldSub = 's.'+lcPrefKeyLevel+lcSubNum

*
*--    
LOCAL lnRecs
lnRecs = UnionObjs('', lcIdObj, tcNumTop)
IF lnRecs = 0
	RETURN 0
ENDIF

*
*--    
*--    
SELECT &lcFldSub, s.id_obj ;
	FROM &lcFile ;
	WHERE &lcFld = lcCode INTO CURSOR ('Obj_'+lcSubNum)

IF _TALLY > 0
	*
	*--   
	*--  
	RETURN UnionObjs(lcSubNum)
ENDIF
RETURN lnRecs
ENDFUNC

*
*/////////////////////////////
*//   
*//  
*//  -
*/////////////////////////////
*
PROCEDURE GetSubObjs(tcNumLel, tcNumSub, toEngine)
IF VARTYPE(tcNumLel) # 'C' OR EMPTY(tcNumLel)
	RETURN 0
ENDIF
IF VARTYPE(tcNumSub) # 'C' OR EMPTY(tcNumSub)
	RETURN 0
ENDIF

LOCAL lcTblCodes, lcFileLev, lcFld, lcFldSub, lcLike;
	,lcPrefNameLevel, lcPrefKeyLevel
WITH toEngine
	lcPrefNameLevel = .cPrefNameLevel
	lcPrefKeyLevel = .cPrefKeyLevel
	lcFileLev = .cDbcName+'!'+lcPrefNameLevel+tcNumSub+' s'
ENDWITH	
lcTblCodes = 'Obj_'+tcNumLel
lcFld = 's.'+lcPrefKeyLevel+tcNumLel
lcFldSub = 's.'+lcPrefKeyLevel+tcNumSub
lcLike = 'Obj_'+tcNumLel+'.'+lcPrefKeyLevel+tcNumLel

SELECT &lcFldSub, s.id_obj ;
	FROM &lcTblCodes, &lcFileLev;
	WHERE &lcFld = &lcLike INTO CURSOR ('Obj_'+tcNumSub)

IF _TALLY > 0
	*
	*--   
	*--  -
	SELECT (lcTblCodes)
	USE 
	*
	*--   
	*--  
	RETURN UnionObjs(tcNumSub)
ENDIF
*
*--   
SELECT ('Obj_'+tcNumSub)
USE 
SELECT (lcTblCodes)
USE 
RETURN 0
ENDFUNC

